const express = require("express");
const mongoose = require("mongoose");
const multer = require('multer'); 
const path = require("path");
const cors = require('cors'); // Import the cors package
const User              = require("./models/user.model.js");
const userRoute         = require("./routes/user.route.js");
const themeRoute        = require("./routes/theme.route.js");
const ServiceRoute      = require("./routes/service.route.js");
const OrganizationRoute = require("./routes/organization.route.js");
const mime              = require('mime');
var fs                  = require('fs');
const MainHelper        = require("./helpers/main.helper");
const { login, getUserByCustomerId, updateUserByCustomerId } = require("./controllers/user.controller.js");
const app = express();
const stripe = require('stripe')(MainHelper.getStripApiKey());
const bodyParser = require("body-parser");



// This is your Stripe CLI webhook secret for testing your endpoint locally.
const endpointSecret = "whsec_686491f521215bac8ebb6053e3a722baededb88368e501daea3824e0b3627542";

app.post('/webhook', express.raw({type: 'application/json'}), async  (request, response) => {
  const sig = request.headers['stripe-signature'];


  let event;


  try {
    event = stripe.webhooks.constructEvent(request.body, sig, endpointSecret);

    // Handle the event
    switch (event.type) {
      case 'customer.subscription.deleted':
        const data = event.data.object;
    
        const userData = await updateUserByCustomerId(data.customer)
       
        break;
      // ... handle other event types
      default:
        
    }
    
  } catch (err) {
  
  }

  // Return a 200 response to acknowledge receipt of the event
  response.send();
});


/*
const corsOptions = {
  credentials: true,
  origin: ['http://localhost:3000', 'http://localhost:80', 'https://test.qrhub.io', 'https://beta.qrhub.io'] // Whitelist the domains you want to allow
};

app.use(cors(corsOptions));
*/


const corsOptions = {
  origin: ['https://beta.mivosroyty-95m321dkz4rv.p.temp-site.link', 'http://beta.mivosroyty-95m321dkz4rv.p.temp-site.link','http://192.168.1.141:3000', 'https://test.qrhub.io', 'https://beta.qrhub.io', 'http://localhost:3000', 'https://4cb9-83-110-103-224.ngrok-free.app'],
};

// app.options('*', cors())
app.use(cors());


// middleware
app.use(express.json({limit: '50mb'}));
app.use(express.urlencoded({extended: true}));
app.use(express.static('public'));

// routes
app.use("/api/users", userRoute);
app.use("/api/services", ServiceRoute);
app.use("/api/themes", themeRoute);
app.use("/api/organization", OrganizationRoute);

app.get("/", (req, res) => {
    res.send("Hello from Node API Server Updated saas");
});


mongoose
  .connect(
    "mongodb+srv://asmryes1991:u7F8HcDNvAGF6TuH@qrhub.jsokk60.mongodb.net/qrhub-API?retryWrites=true&w=majority&appName=qrhub"
  )
  .then(() => {
    console.log("Connected to database!");

    app.listen(5000, () => {
      console.log("Server is running on port 5000 :)");
    });
   
  })
  .catch((e) => {
    console.log("Connection failed! "+e.message);
});
